#pragma once

#include "CoreMinimal.h"
#include "Tile.h"

/**
 * Represents a building in the city - a single solid tile with doors. Can be used as a home by agents.
 */
class CV10_DAV_API FBuildingTile : public FTile
{
public:
	FBuildingTile(int X, int Y, int W, int H, int Z);
	virtual ~FBuildingTile() = default;

	virtual int GenerateMesh(TArray<FVector>& Vertices, TArray<FVector>& Normals, TArray<int32>& Indices, TArray<FVector2D>& UVs, const int IndexOffset, TArray<FLinearColor>& Color);

	virtual int GetTileType();

	virtual FVector NearestWallNormal(const FVector& Pos) const;
	FVector DoorLocation(FTile* Street);
};
