#pragma once

#include "CoreMinimal.h"
#include "ProceduralMeshComponent.h"

/**
 * Settings for the city layout.
 */
class CV10_DAV_API FCitySettings
{
public:
	UProceduralMeshComponent* Mesh;
	UTexture2D* Layout;
	UMaterial* Material;
	int32 Spacing;
	int32 Height;
	int32 FoodmarketLimit;
	int32 FoodmarketAgentsRow;
};

/**
 *	Settings for individual agents, these get applied when an agent is created.
 */
class CV10_DAV_API FAgentSettings
{
public:
	float Size;
	float PersonalSpace;
	float Pushing;
	float WalkCheckpointTolerance;
	float Radius;
	float HungerLevel;

	float FoodCapacity;
	float FoodHungerDelta;
	float FoodEatingDelta;
	float PatienceLimit;
	float PatienceDelta;
	float TalkingDistance;

	float WeightWallRepulsion;
	float WeightAgentRepulsion;
	float WeightWallAvoidance;
	float WeightAgentAvoidance;
	float WeightSteeringForce;
};