#pragma once

#include "CoreMinimal.h"
#include "BuildingTile.h"

/**
 *	Represents a restaurant tile where agents can get food when hungry.
 */
class CV10_DAV_API FFoodTile : public FBuildingTile
{
public:
	FFoodTile(int X, int Y, int W, int H, int Z, int AgentsLimit, int AgentsInRow);
	virtual ~FFoodTile() = default;

	virtual int GenerateMesh(TArray<FVector>& Vertices, TArray<FVector>& Normals, TArray<int32>& Indices, TArray<FVector2D>& UVs, const int IndexOffset, TArray<FLinearColor>& Color);

	virtual int GetTileType();

	bool TryAgentGetInside();
	void AgentGetOut(const FAgent* Agent);

	FVector GetInsideAgentPosition(const FAgent* Agent);

protected:
	int32 CustomersLimit;
	int32 CustomersPresent;
	int32 DisplayAgentRow;

	TArray<const FAgent*> Customers;
};
