#pragma once

#include "CoreMinimal.h"
#include "CityMap.h"


enum EWalkStatus {
	Walking,
	Finished
};

/**
 *	Represents the Walking action and implements basic BFS pathfinding.
 */
class CV10_DAV_API FWalk
{
public:
	FWalk();
	FWalk(const FVector Start, const FVector End, const FCityMap* Map, const float Tolerance);
	FWalk(const FVector Start, const FVector End, const float Tolerance);
	~FWalk();

	int GetForce(const FVector AgentLoc, FVector& Force);
	bool EndReached();

protected:

	void BFS(TMap<const FTile*, const FTile*>& Pred,
		const FTile* StartTile, const FTile* EndTile);

	TArray<FVector> Checkpoints;
	float Tolerance;

};
